<!--
 * @Descripttion: (店铺/tb_shop)
 * @version: (1.0)
 * @Author: (lwh)
 * @Date: (2023-06-09)
 * @LastEditors: (lwh)
 * @LastEditTime: (2023-06-09)
-->
<template>
  <div class="app-container">
    <el-row :gutter="24">
      <!-- 搜索框 queryParams.需要搜索的字段 -->
      <el-form :model="queryParams" label-position="left" style="margin:15px;" inline ref="queryForm" v-show="showSearch"
        @submit.prevent>
        <el-form-item label="名称" prop="shopName">
          <el-input v-model="queryParams.shopName" placeholder="请输入名称" clearable @keyup.enter="handleQuery" />
        </el-form-item>
        <el-form-item label="审核状态" prop="shopAuditStatus">
          <el-select v-model="queryParams.shopAuditStatus" placeholder="请选择审核状态" clearable @change="handleQuery">
            <el-option v-for="item in  audit_status " :key="item.dictValue" :label="item.dictLabel"
              :value="item.dictValue"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item>
          <el-button icon="search" type="primary" @click="handleQuery">{{ $t('btn.search') }}</el-button>
          <el-button icon="refresh" @click="resetQuery">{{ $t('btn.reset') }}</el-button>
        </el-form-item>
      </el-form>
    </el-row>

    <!-- 工具按钮 -->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" v-hasPermi="['business:shop:addOrUpdate']" plain icon="plus"
          @click="AddDialogVisible = true">
          {{ $t('btn.add') }}
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" :disabled="multiple" v-hasPermi="['business:shop:delete']" plain icon="delete"
          @click="handleDelete">
          {{ $t('btn.delete') }}
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" :disabled="multiple" v-hasPermi="['business:shop:audit']" plain icon="check"
          @click="handleAudit">审核</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="download" @click="handleExport" v-hasPermi="['business:shop:export']">
          {{ $t('btn.export') }}
        </el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <!-- 表格渲染  prop="对应的字段"-->
    <el-table v-loading="loading" :data="dataList" ref="tableRef" highlight-current-row
      @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="50" align="center" />

      <el-table-column prop="userName" label="用户" align="center">
        <template #default="scope">
          <div v-if="!scope.row.userName">暂未绑定</div>
          <div v-else>{{ scope.row.userName }}</div>
        </template>
      </el-table-column>
      <el-table-column prop="customerNickname" label="客户" align="center" />
      <el-table-column prop="shopBusinessCategoryName" label="经营类目" align="center">
        <template #default="scope">
          <el-tag>{{ scope.row.shopBusinessCategoryName }}</el-tag>
        </template>
      </el-table-column>
      <el-table-column prop="shopName" label="名称" align="center" :show-overflow-tooltip="true" />
      <el-table-column prop="shopLogo" label="图标" align="center">
        <template #default="scope">
          <el-image preview-teleported :hide-on-click-modal="true" lazy class="table-td-thumb" fit="contain"
            :src="scope.row.shopLogo.split(',')[0]" :preview-src-list="scope.row.shopLogo.split(',')">
            <div><el-icon :size="15">
                <document />
              </el-icon></div>
          </el-image>
        </template>
      </el-table-column>
      <el-table-column prop="shopSalesOrderCount" label="销售单量" align="center" sortable />
      <el-table-column prop="shopSort" label="排序" align="center" sortable />
      <el-table-column prop="shopAuditStatus" label="审核状态" align="center">
        <template #default="scope">
          <dict-tag :options="audit_status" :value="scope.row.shopAuditStatus" />
        </template>
      </el-table-column>
      <el-table-column prop="createTime" label="创建时间" align="center" />

      <el-table-column label="操作" width="350" fixed="right">
        <template #default="scope">
          <el-button type="warning" v-if="scope.row.shopAuditStatus == 1" size="small" icon="check"
            @click="handleAudit(scope.row)" v-hasPermi="['business:shop:audit']">审核</el-button>
          <el-button type="primary" v-if="scope.row.shopAuditStatus == 2" size="small" icon="edit"
            @click="handleUpdate(scope.row)" v-hasPermi="['business:shop:addOrUpdate']">编辑</el-button>
          <el-button type="danger" size="small" icon="delete" @click="handleDelete(scope.row)"
            v-hasPermi="['business:shop:delete']">删除</el-button>
          <el-button size="small" icon="view" @click="handleDetail(scope.row)">查看</el-button>
        </template>
      </el-table-column>

    </el-table>
    <pagination :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize"
      @pagination="getList" />
  </div>

  <!-- 添加 -->
  <AddDialog v-model="AddDialogVisible" :done="() => resetQuery()"></AddDialog>
  <!-- 编辑 -->
  <EditDialog v-model="EditDialogVisible" :data="EditDialogRow" :done="() => resetQuery()"></EditDialog>
  <!-- 详情 -->
  <DetailDialog v-model="DetailDialogVisible" :data="DetailDialogRow" :done="() => resetQuery()"></DetailDialog>
</template>
<script setup name="shop">
import { ElMessageBox } from 'element-plus'
import modal from '@/plugins/modal.js'
import { exportShop, audit, shopList, delShop } from '@/api/business/ShopManager/Shops/shop.js'
import AddDialog from "./components/AddDialog.vue";
import EditDialog from "./components/EditDialog.vue";
import DetailDialog from "./components/DetailDialog.vue";

const AddDialogVisible = ref(false);
const EditDialogVisible = ref(false);
const EditDialogRow = ref({});
const DetailDialogVisible = ref(false);
const DetailDialogRow = ref({});

const { proxy } = getCurrentInstance()

// 选中categoryId数组数组
const ids = ref([])
// 非单选禁用
const single = ref(true)
// 非多个禁用
const multiple = ref(true)
// 显示搜索条件
const showSearch = ref(true)
// 数据列表
const dataList = ref([])
// 总记录数
const total = ref(0)
// 是否加载
const loading = ref(true)

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10
  },
})
const { queryParams } = toRefs(data)

// 业务参数


// 业务方法

// 字典获取
const audit_status = ref([]);
async function getaudit_status() {
  await proxy.getDicts('audit_status').then((res) => {
    audit_status.value = res.data
  })
}
getaudit_status()




//基础方法

// 查询数据
function getList() {
  loading.value = true


  shopList(queryParams.value).then((res) => {
    if (res.code == 200) {
      loading.value = false;
      dataList.value = res.data.result;
      total.value = res.data.totalNum;
    }
  });
}


// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map((item) => item.shopId)
  single.value = selection.length != 1
  multiple.value = !selection.length
}

/** 重置查询操作 */
function resetQuery() {
  proxy.resetForm('queryForm')
  handleQuery()
}
/** 搜索按钮操作 */
function handleQuery() {
  getList()
}
/** 删除按钮操作 */
function handleDelete(row) {
  const Ids = row.shopId || ids.value

  ElMessageBox.confirm("是否确认删除？", "系统提示", {
    confirmButtonText: '确定',
    cancelButtonText: '取消',
    type: "warning",
  })
    .then(function () {
      return delShop(Ids)
    })
    .then(() => {
      handleQuery()
      modal.msgSuccess("删除成功")
    })
    .catch(() => { })
}

/** 导出按钮操作 */
function handleExport(row) {
  const Ids = row.shopId || ids.value
  const name = ref("所有")

  if (Ids.length != 0) {
    const ids = Object.values(Ids).map(value => String(value));
    const str = ids.join(',');
    queryParams.value.ids = str
    name.value = "选中"
  }

  ElMessageBox.confirm('是否确认导出' + name.value + '数据?', '警告', {
    confirmButtonText: '确定',
    cancelButtonText: '取消',
    type: 'warning',
  })
    .then(function () {
      return exportShop(queryParams.value)
    })
    .then((response) => {
      proxy.download(response.data.path)
    })
}

/** 审核按钮操作 */
const AuditData = reactive({
  ids: null,
  shopAuditStatus: null,
})
function handleAudit(row) {
  const Ids = row.shopId || ids.value.toString()

  ElMessageBox.confirm("是否通过审核？", "系统提示", {
    distinguishCancelAndClose: true,
    confirmButtonText: '通过',
    cancelButtonText: '驳回',
    type: "warning",
  })
    .then(async () => {
      AuditData.shopAuditStatus = 2
      AuditData.ids = Ids
      Audit()
    })
    .catch((action) => {
      if (action == 'cancel') {
        AuditData.shopAuditStatus = 3
        AuditData.ids = Ids
        Audit()
        // console.log("拒绝");
      }
      else {
        // console.log("关闭");
      }
    })
}
async function Audit() {
  audit(AuditData).then((res) => {
    if (res.code == 200) {
      handleQuery()
      ElMessageBox.alert(res.data, "审核信息", {
        dangerouslyUseHTMLString: true,
        confirmButtonText: "确定",
      });
    } else {
      ElMessage.error(res.data);
    }
  })
}

// 修改
function handleUpdate(row) {
  EditDialogVisible.value = true
  EditDialogRow.value = row
}

// 详情
function handleDetail(row) {
  DetailDialogVisible.value = true
  DetailDialogRow.value = row
}

handleQuery()
</script>
